// HTML5 placeholder plugin version 1.01
// Copyright (c) 2010-The End of Time, Mike Taylor, http://miketaylr.com
// MIT Licensed: http://www.opensource.org/licenses/mit-license.php
//
// Enables cross-browser HTML5 placeholder for inputs, by first testing
// for a native implementation before building one.
//
//
// USAGE: 
//$('input[placeholder]').placeholder();
var reg11 = /placeholder="(.*?)"|placeholder=(.*?)[\s>]/;
// <input type="text" placeholder="username">
(function($){
  //feature detection
  var hasPlaceholder = 'placeholder' in document.createElement('input');
  
  //sniffy sniff sniff -- just to give extra left padding for the older
  //graphics for type=email and type=url
  //var isOldOpera = $.browser.opera && $.browser.version < 10.5;

  $.fn.placeholder = function(options) {
    //merge in passed in options, if any
    var options = $.extend({}, $.fn.placeholder.defaults, options),
    //cache the original 'left' value, for use by Opera later
    o_left = options.placeholderCSS.left;
  
    //first test for native placeholder support before continuing
    //feature detection inspired by ye olde jquery 1.4 hawtness, with paul irish
    return (hasPlaceholder) ? this.wrap('<span style="position:relative;display:inline-block;"></span>') : this.each(function() {
  	  //TODO: if this element already has a placeholder, exit
    
      //local vars
      
      var $this = $(this),
          inputVal = $.trim($this.val()),
          inputWidth = $this.width()?$this.width():$this.css("width"),
          inputHeight = $this.height()?$this.height():$this.css("height"),
          //grab the inputs id for the <label @for>, or make a new one from the Date
          inputId = (this.id) ? this.id : 'placeholder' + (+new Date())+Math.random()*10,
          //placeholderText = $this.attr('placeholder'),
          //placeholderText = (navigator.appVersion.match(/7./i)=="7.")?(reg11.exec(this.outerHTML)[1]==""?reg11.exec(this.outerHTML)[2]:reg11.exec(this.outerHTML)[1]):$this.attr('placeholder'),
          placeholderText = hasPlaceholder?$this.attr('placeholder'):(reg11.exec(this.outerHTML)[1]==""?reg11.exec(this.outerHTML)[2]:reg11.exec(this.outerHTML)[1]),
          placeholder = $('<label for='+ inputId +'>'+ placeholderText + '</label>');
         // alert(placeholder.parent().position().top);
      //stuff in some calculated values into the placeholderCSS object
      //options.placeholderCSS['width'] = inputWidth;
      if(navigator.appName === "Microsoft Internet Explorer" && parseInt((navigator.appVersion.toLowerCase()).match(/msie ([\d.]+)/)[1])==6 && placeholderText != '页码'){
      	options.placeholderCSS['width'] = 'auto';
      }else{
      	options.placeholderCSS['width'] = inputWidth;
      }
      options.placeholderCSS['height'] = inputHeight;
      options.placeholderCSS['color'] = options.color;
      // adjust position of placeholder 
      //options.placeholderCSS.left = (isOldOpera && (this.type == 'email' || this.type == 'url')) ? '11%' : o_left;
      options.placeholderCSS.left = ((this.type == 'email' || this.type == 'url')) ? '11%' : o_left;
      
      if(options.sign){//增加sign用于区分登录页与其他页面
      	options.placeholderCSS['font'] = '14px sans-serif';
      	options.placeholderCSS['top'] ='10px';
      	options.placeholderCSS['text-align'] = 'left';
      }
      
      placeholder.css(options.placeholderCSS);
    
      //place the placeholder
      $this.wrap(options.inputWrapper);
      $this.attr('id', inputId).after(placeholder);
    //  alert(placeholder.parent().position().top);
     // placeholder.parent().css({"top":"7px"});
    //  alert(placeholder.parent().position().top);
    //  if(placeholder.position().top!=6)
     // {
     	//options.placeholderCSS['top']=-10;
     	//placeholder.css(options.placeholderCSS);
     // }
      //if the input isn't empty
      if (inputVal){
        placeholder.hide();
      };
    
      //hide placeholder on focus
      $this.focus(function(){
        if (!$.trim($this.val())){
          placeholder.hide();
        };
      });
      
      
      
      
      //show placeholder if the input is empty
      $this.blur(function(){
        if (!$.trim($this.val())){
          placeholder.show();
        };
      });
    });
  };
  
  //expose defaults
  $.fn.placeholder.defaults = {
    //you can pass in a custom wrapper
    inputWrapper: '<span style="position:relative;display:inline-block;"></span>',
  
    //more or less just emulating what webkit does here
    //tweak to your hearts content
    placeholderCSS: {
      'font':'12px sans-serif', 
      'color':'#bababa', 
      'position': 'absolute', 
      'left':'5px',
      'top':'6px', 
      'overflow-x': 'hidden',
	  'display': 'block'
    }
  };
})(jQuery);
